//
// Copyright (c) 2009 Froduald Kabanza and the Université de Sherbrooke.
// Use of this software is permitted for non-commercial research purposes, and
// it may be copied or applied only for that use. All copies must include this
// copyright message.
// 
// This is a research prototype that has not gone through intensive tests and
// is delivered as is. It may still contain bugs. Froduald Kabanza and the
// Université de Sherbrooke disclaim any responsibility for damage that may be
// caused by using it.
//
// Please note that some files were inspired in part by the PDDL4J library:
// http://www.math-info.univ-paris5.fr/~pellier/software/software.php 
//
// Implementation: Simon Chamberland
// Project Manager: Froduald Kabanza
//

#ifndef _AT_END_CONSTRAINT_EXP_H
#define _AT_END_CONSTRAINT_EXP_H

#include "../ILogicalExp.h"

namespace planning
{
  /// <summary>
  /// Represents a constraint expression which must be evaluated at the end of the trajectory.
  /// </summary>
  class AtEndExp : public ITemporalExp
  {
  public:
    AtEndExp(const ILogicalExp *exp)
      : m_exp(exp)
    {
      assert(m_exp != NULL);

      m_exp->acquire(this);

      INITIALIZE_HASH_CODE();
    }

    ~AtEndExp()
    {
      m_exp->release(this);
    }

    virtual ProgressionValue progress(const IDurativeClosedWorld* world, const Bindings* bindings) const;

    virtual bool evaluateIdle(const IDurativeClosedWorld* world, const Bindings* bindings) const;

  protected:
    virtual void _output(std::ostream& out) const;

    virtual size_t _calculateHashCode() const
    {
      return 8 * m_exp->getHashCode()
           + 9377;
    }

    virtual const IExp* _internalApply(const Bindings* bindings) const;

    virtual int _internalCompareTo(const IExp& other) const;

  private:
    const ILogicalExp* m_exp;
  };
}

#endif